/*
 * Exemple simple d'utilisation des mutexes
 */

#include <pthread.h> /* pour les fonctions pthread */
#include <stdio.h>
#include <unistd.h>
#include <stdint.h> /* pour intptr_t */
#include <sys/time.h>

pthread_mutex_t mutex = PTHREAD_MUTEX_INITIALIZER;

/* Bricolage pour afficher l'heure, inutile de lire */
struct timeval tv0;
#define PRINT(fmt, ...) do { \
	struct timeval tv; \
	gettimeofday(&tv, NULL); \
	fprintf(stderr, "%u.%u: " fmt, (unsigned) (tv.tv_sec - tv0.tv_sec), (unsigned) tv.tv_usec, ## __VA_ARGS__); \
} while (0)

void *f(void *parametre) {
	int n = (intptr_t) parametre;

	int i;
	/* Chacun travaille 2 ou 4 fois */
	for (i = 0; i < n*2; i++) {
		PRINT("%d va prendre le verrou\n", n);
		pthread_mutex_lock(&mutex);
		PRINT("%d a pris le verrou, et bosse avec\n", n);
		sleep(1);
		PRINT("%d va relâcher le verrou\n", n);
		pthread_mutex_unlock(&mutex);
		PRINT("%d a relâché le verrou, et fait autre chose\n", n);
		sleep(2);
	}

	/* Et termine */
	return NULL;
}

/* Thread principal */
int main(void) {
	pthread_t t1, t2;

	gettimeofday(&tv0, NULL);

	pthread_create(&t1, NULL, f, (void*)(intptr_t) 1);
	pthread_create(&t2, NULL, f, (void*)(intptr_t) 2);

	pthread_join(t1, NULL);
	PRINT("t1 a fini !\n");

	pthread_join(t2, NULL);
	PRINT("t2 a fini !\n");

	return 0;
}
